use conjure_object::serde::{ser, de};
use conjure_object::serde::ser::SerializeMap as SerializeMap_;
use conjure_object::private::{UnionField_, UnionTypeField_};
use std::fmt;
#[derive(Debug, Clone, PartialEq, Eq, PartialOrd, Ord, Hash)]
pub enum ChecklistLiveStatus {
    /// The streaming checklist is currently executing against the asset.
    Running(super::StreamingChecklistRunning),
    /// The streaming checklist is currently initializing against the asset.
    Initializing(super::StreamingChecklistInitializing),
    /// The streaming checklist failed unexpectedly. Please contact support.
    Failed(super::StreamingChecklistFailed),
    /// An unknown variant.
    Unknown(Unknown),
}
impl ser::Serialize for ChecklistLiveStatus {
    fn serialize<S>(&self, s: S) -> Result<S::Ok, S::Error>
    where
        S: ser::Serializer,
    {
        let mut map = s.serialize_map(Some(2))?;
        match self {
            ChecklistLiveStatus::Running(value) => {
                map.serialize_entry(&"type", &"running")?;
                map.serialize_entry(&"running", value)?;
            }
            ChecklistLiveStatus::Initializing(value) => {
                map.serialize_entry(&"type", &"initializing")?;
                map.serialize_entry(&"initializing", value)?;
            }
            ChecklistLiveStatus::Failed(value) => {
                map.serialize_entry(&"type", &"failed")?;
                map.serialize_entry(&"failed", value)?;
            }
            ChecklistLiveStatus::Unknown(value) => {
                map.serialize_entry(&"type", &value.type_)?;
                map.serialize_entry(&value.type_, &value.value)?;
            }
        }
        map.end()
    }
}
impl<'de> de::Deserialize<'de> for ChecklistLiveStatus {
    fn deserialize<D>(d: D) -> Result<ChecklistLiveStatus, D::Error>
    where
        D: de::Deserializer<'de>,
    {
        d.deserialize_map(Visitor_)
    }
}
struct Visitor_;
impl<'de> de::Visitor<'de> for Visitor_ {
    type Value = ChecklistLiveStatus;
    fn expecting(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt.write_str("union ChecklistLiveStatus")
    }
    fn visit_map<A>(self, mut map: A) -> Result<ChecklistLiveStatus, A::Error>
    where
        A: de::MapAccess<'de>,
    {
        let v = match map.next_key::<UnionField_<Variant_>>()? {
            Some(UnionField_::Type) => {
                let variant = map.next_value()?;
                let key = map.next_key()?;
                match (variant, key) {
                    (Variant_::Running, Some(Variant_::Running)) => {
                        let value = map.next_value()?;
                        ChecklistLiveStatus::Running(value)
                    }
                    (Variant_::Initializing, Some(Variant_::Initializing)) => {
                        let value = map.next_value()?;
                        ChecklistLiveStatus::Initializing(value)
                    }
                    (Variant_::Failed, Some(Variant_::Failed)) => {
                        let value = map.next_value()?;
                        ChecklistLiveStatus::Failed(value)
                    }
                    (Variant_::Unknown(type_), Some(Variant_::Unknown(b))) => {
                        if type_ == b {
                            let value = map.next_value()?;
                            ChecklistLiveStatus::Unknown(Unknown { type_, value })
                        } else {
                            return Err(
                                de::Error::invalid_value(de::Unexpected::Str(&type_), &&*b),
                            )
                        }
                    }
                    (variant, Some(key)) => {
                        return Err(
                            de::Error::invalid_value(
                                de::Unexpected::Str(key.as_str()),
                                &variant.as_str(),
                            ),
                        );
                    }
                    (variant, None) => {
                        return Err(de::Error::missing_field(variant.as_str()));
                    }
                }
            }
            Some(UnionField_::Value(variant)) => {
                let value = match &variant {
                    Variant_::Running => {
                        let value = map.next_value()?;
                        ChecklistLiveStatus::Running(value)
                    }
                    Variant_::Initializing => {
                        let value = map.next_value()?;
                        ChecklistLiveStatus::Initializing(value)
                    }
                    Variant_::Failed => {
                        let value = map.next_value()?;
                        ChecklistLiveStatus::Failed(value)
                    }
                    Variant_::Unknown(type_) => {
                        let value = map.next_value()?;
                        ChecklistLiveStatus::Unknown(Unknown {
                            type_: type_.clone(),
                            value,
                        })
                    }
                };
                if map.next_key::<UnionTypeField_>()?.is_none() {
                    return Err(de::Error::missing_field("type"));
                }
                let type_variant = map.next_value::<Variant_>()?;
                if variant != type_variant {
                    return Err(
                        de::Error::invalid_value(
                            de::Unexpected::Str(type_variant.as_str()),
                            &variant.as_str(),
                        ),
                    );
                }
                value
            }
            None => return Err(de::Error::missing_field("type")),
        };
        if map.next_key::<UnionField_<Variant_>>()?.is_some() {
            return Err(de::Error::invalid_length(3, &"type and value fields"));
        }
        Ok(v)
    }
}
#[derive(PartialEq)]
enum Variant_ {
    Running,
    Initializing,
    Failed,
    Unknown(Box<str>),
}
impl Variant_ {
    fn as_str(&self) -> &'static str {
        match *self {
            Variant_::Running => "running",
            Variant_::Initializing => "initializing",
            Variant_::Failed => "failed",
            Variant_::Unknown(_) => "unknown variant",
        }
    }
}
impl<'de> de::Deserialize<'de> for Variant_ {
    fn deserialize<D>(d: D) -> Result<Variant_, D::Error>
    where
        D: de::Deserializer<'de>,
    {
        d.deserialize_str(VariantVisitor_)
    }
}
struct VariantVisitor_;
impl<'de> de::Visitor<'de> for VariantVisitor_ {
    type Value = Variant_;
    fn expecting(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt.write_str("string")
    }
    fn visit_str<E>(self, value: &str) -> Result<Variant_, E>
    where
        E: de::Error,
    {
        let v = match value {
            "running" => Variant_::Running,
            "initializing" => Variant_::Initializing,
            "failed" => Variant_::Failed,
            value => Variant_::Unknown(value.to_string().into_boxed_str()),
        };
        Ok(v)
    }
}
///An unknown variant of the ChecklistLiveStatus union.
#[derive(Debug, Clone, PartialEq, Eq, PartialOrd, Ord, Hash)]
pub struct Unknown {
    type_: Box<str>,
    value: conjure_object::Any,
}
impl Unknown {
    /// Returns the unknown variant's type name.
    #[inline]
    pub fn type_(&self) -> &str {
        &self.type_
    }
}
